<?php

	require_once("../Util/Constant.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Control.php");

	class CompoundControl extends Control
	{
		function CompoundControl($name, $parent)
		{
			parent::Control($name, $parent);
		}
		
		var $Controls = array();
		function AddControl ( $control )
		{
			array_push ( $this->Controls, $control );
		}
		
		//////////////////////////////////////////////////
		//
		// 		On Request - This is where 'Request' is
		//			processed. Here syncronization of
		//			controls should take place from Request
		//			to variables.
		//
		function __protected__OnRequest()
		{
			foreach ( $this->Controls as $c )
			{
				$c->__protected__OnRequest();
			}
			parent::__protected__OnRequest();
		}
			
		function __protected__OnRequestNormal()
		{
		}

		function __protected__OnRequestSelect()
		{
		}

		function __protected__OnRequestEdit()
		{
		}

		//////////////////////////////////////////////////
		//
		// 		On Process - This is where drawing
		//		and displaying logic should reside
		//
		function __protected__OnProcess()
		{
			foreach ( $this->Controls as $c )
			{
				$c->__protected__OnProcess();
			}	
			parent::__protected__OnProcess();		
		}

		function __protected__OnProcessNormal()
		{
		}

		function __protected__OnProcessSelect()
		{
		}

		function __protected__OnProcessEdit()
		{
		}
			
		//////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//
		function __protected__OnResponse()
		{
			// No need for such as loop because OnResponse
			// usually prints the control. 
			//
			foreach ( $this->Controls as $c )
			{
				$c->__protected__OnResponse();
			}			
			parent::__protected__OnResponse();
		}
			
		function __protected__OnResponseNormal()
		{
		}
			
		function __protected__OnResponseSelect()
		{
		}
			
		function __protected__OnResponseEdit()
		{
		}
	}
	
?>