<?php

	require_once("../Util/Constant.php");
	
	require_once( CONST_DIR_DATA_PROTECTION()."/Util/Platform.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Control/Control.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Compound/CompoundControl.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Compound/Section.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Compound/LinkBar.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Control/SlideShow.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Util/Log.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Util/Util.php");
	require_once( CONST_DIR_DATA_PROTECTION()."/Util/Array.php");

?>

<?php

	class Page extends CompoundControl
	{
		function Page ($name, $parent)
		{
			parent::Control($name, $parent);
			
		}
		
		//////////////////////////////////////////////////
		//
		// Controls
		//
		var $DocumentNavigationBar;
		var $LeftNavigationBar;
		var $Title;
		var $SubTitle;
		var $LastUpdate;
		
		//////////////////////////////////////////////////
		//
		//
		//
		function BuildFromXml ()
		{
			$dom = domxml_open_file( CONST_XML_FILE_DATA_PROTECTION() );
			$xmlnodeRoot = $dom->document_element();
			
			/************************************************************
									ROOT
			************************************************************/
			
			$codeStart 			= $xmlnodeRoot->get_attribute("CodeStart");
			$codeEnd 			= $xmlnodeRoot->get_attribute("CodeEnd");
			$this->LastUpdate 	= $xmlnodeRoot->get_attribute("LastUpdate");
			$mode 				= $xmlnodeRoot->get_attribute("Mode");
			
			$_SESSION["Mode"]=$mode;
			
			$xmlnodePageList = $xmlnodeRoot->get_elements_by_tagname("Page");
			foreach ( $xmlnodePageList as $xmlnodePage )
			{
				/************************************************************
										PAGE
				************************************************************/
				
				$title = $xmlnodePage->get_attribute("Title");
				$subTitle = $xmlnodePage->get_attribute("SubTitle");
				
				$this->Title = $title;
				$this->SubTitle = $subTitle;
		
				$this->DocumentNavigationBar = new LinkBar( "DocNavBar", $this );
				$this->DocumentNavigationBar->Orientation = "vertical";
				$this->DocumentNavigationBar->FontColor = "white";
				$this->DocumentNavigationBar->HorizontalAlign = "left";
				$this->DocumentNavigationBar->Heading = $title;
		
				$xmlnodePageChildren = $xmlnodePage->child_nodes();
				foreach ( $xmlnodePageChildren as $xmlnodePageChild )
				{
					if ( $xmlnodePageChild->node_type() == XML_ELEMENT_NODE )
					{
						switch ( $xmlnodePageChild->tagname() )
						{
							/************************************************************
													SECTION
							************************************************************/
							case "Section" :
									
									$xmlnodeSection = $xmlnodePageChild;
									$id = $xmlnodeSection->get_attribute("ID");				
	
									$section = new Section($id, null);
									$success = $section->BuildFromXmlNode( $xmlnodeSection );
									
									if ( $success == true )
									{
										$this->AddControl( $section );
										
										$xmlnodeHeadingList = $xmlnodeSection->get_elements_by_tagname("Heading");
										if ( $xmlnodeHeadingList != null  )
										{
											$count = count ( $xmlnodeHeadingList );
											if ( $count == 1 )
											{
												$xmlnodeHeading = $xmlnodeHeadingList[0];
												$name = $xmlnodeHeading->get_content();
												$this->DocumentNavigationBar->AddLink( "#", $id, $name );
											}
											else if ( $count > 1 )
											{
												print ( "Warning : Only supposed to have 1 heading");
											}
											else if ( $count < 1 )
											{
												// simply ignore it
											}
										}
									}
									break;
							
							/************************************************************
													LINK BAR
							************************************************************/
							case "LinkBar" :
									
									$xmlnodeLinkBar = $xmlnodePageChild;
									
									$linkBar = new LinkBar( "linkBar", $this );
									$linkBar->Orientation = "horizontal";
									$linkBar->HorizontalAlign = "right";
	
									$success = $linkBar->BuildFromXmlNode( $xmlnodeLinkBar );
									
									if ( $success == true )
										$this->AddControl( $linkBar );
									
									break;
		
							/************************************************************
													NAVIGATION BAR
							************************************************************/
							case "NavigationBar" :
							
									$xmlnodeNavigationBar = $xmlnodePageChild;
									$xmlnodeNavBarCategoryList = $xmlnodeNavigationBar->get_elements_by_tagname("Category");
									foreach ( $xmlnodeNavBarCategoryList as $xmlnodeNavBarCategory )
									{
										$this->LeftNavigationBar = new LinkBar( "linkBar", $this );
										$this->LeftNavigationBar->Orientation = "vertical";
										$this->LeftNavigationBar->FontColor = "white";
										$this->LeftNavigationBar->HorizontalAlign = "left";
										
										$success = $this->LeftNavigationBar->BuildFromXmlNode( $xmlnodeNavBarCategory );
									}
									break;
									
							/************************************************************
													DEFAULT
							************************************************************/
							default :
								print ( "Unable to interpret Xml Tag ".$xmlnodePageChild->tagname() );
						}
					}
				}
			}
		}
		
		//////////////////////////////////////////////////
		//
		// 		On Request - This is where 'Request' is
		//			processed. Here syncronization of
		//			controls should take place from Request
		//			to variables.
		//
		function __protected__OnRequest()
		{
			parent::__protected__OnRequest();
		}
			
		function __protected__OnRequestNormal()
		{
		}

		function __protected__OnRequestSelect()
		{
		}

		function __protected__OnRequestEdit()
		{
		}

		//////////////////////////////////////////////////
		//
		// 		On Process - This is where drawing
		//		and displaying logic should reside
		//
		function __protected__OnProcess()
		{
			parent::__protected__OnProcess();
		}

		function __protected__OnProcessNormal()
		{
		}

		function __protected__OnProcessSelect()
		{
		}

		function __protected__OnProcessEdit()
		{
		}
			
		//////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//
		function __protected__OnResponse()
		{
			parent::__protected__OnResponse();
		}
			
		function __protected__OnResponseNormal()
		{
		}
			
		function __protected__OnResponseSelect()
		{
		}
			
		function __protected__OnResponseEdit()
		{
		}
	}
	
?>