<?php

	require_once("../Util/Constant.php");

	session_start();
	
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Log.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Util.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Array.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Util/Platform.php");
	// Uncommenting the include/require below cause 
	// duplicate definition error !
	// require_once("InfoFtp.php" );
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Control.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/ProgressBar.php" );
	require_once(CONST_DIR_DATA_PROTECTION()."/Server/ManagerSoftwareDeployment.php");
	
?>

<!-- -------------------------------------------------------------------------
------------------------------------------------------------------------------

						DOWNLOAD [Server]
					
------------------------------------------------------------------------------					
-------------------------------------------------------------------------- -->

<?php


	class DownloadServer extends Control 
	{
		var $sectionId;
		var $software;
		
		function DownloadServer ( $sectionId )
		{
			parent::Control($sectionId, null); 	// Todo : always pass null for parent because parent helps in forming full name to make it unique. 
											// 		In case of download, server and client may reside on different parent controls, thus forming
											//		different fullnames and causing confusion b/w server and client, while finding each other. 
											//		full name of a control is it's own name + parent name + parent's parent's name + .....
			$this->sectionId = $sectionId;											
		}
		
		function __protected__OnResponse()
		{
			$this->software = SwDeployMANAGER( $this->sectionId );											

			$fileSize = $this->software->DownloadInfo->LocalSizeCurrent();
			$totalSize = $this->software->Source->FTP->RemoteSizeMax;

			$pb = new ProgressBarServer( "progress_bar", $this );
			$pb->CurrentProgress = $fileSize / $totalSize * 100;
			$pb->MessageFromServer = round( $fileSize / 1024 / 1024, 2 )." MB of ".round( $totalSize / 1024 / 1024, 2)." MB";
			$pb->__protected__OnResponse();
		}
	}

?>

<!-- ---------------------------------------------------------------------------------
--------------------------------------------------------------------------------------
							
						DOWNLOAD SERVER - Uses SectionId passed as parameter
								in QueryString, to build DownloadServer that
								in turn updates the client.
							
--------------------------------------------------------------------------------------							
--------------------------------------------------------------------------------- -->

<?php

	$sectionId = $_REQUEST["SectionId"]; // From request extract SectionId 	// $sectionId = "LTT_LOCAL_REQUEST";
	$software = SwDeployMANAGER( $sectionId );
	
	if ( $software != null )
	{	
		//
		// Create a download server for the section that is passed as SectionId
		// and execute i.e. Display() it. Download server resides in 'control' folder
		//
		
		$downloadServer = new DownloadServer( $sectionId );
		$downloadServer->Display();
	}
	else 
	{
		print ( __FILE__." - OS [".$os."] in SectionId [".$sectionId."] not found");
	}

?>