<?php

	/* -------------------------------------------------------------------------
	----------------------------------------------------------------------------
	
						Install Client
	
	----------------------------------------------------------------------------					
	-------------------------------------------------------------------------- */
	require_once ("../Util/Constant.php");
	require_once(CONST_DIR_DATA_PROTECTION()."/Control/Control.php");

	class InstallClient extends Control
	{
		var $Title = '';
		var $ServerURL = '';
		var $MessageFromClient = '';
		
		function InstallClient($sectionId, $serverUrl)
		{
			parent::Control($sectionId, null);		// Todo : always pass null for parent because parent helps in forming full name to make it unique. 
													// 		In case of download, server and client may reside on different parent controls, thus forming
													//		different fullnames and causing confusion b/w server and client, while finding each other. 
													//		full name of a control is it's own name + parent name + parent's parent's name + .....
			$this->ServerURL = $serverUrl;
		}
		
		function GetSectionId()
		{
			return $this->Name;
		}
		
		function SetSectionId ( $sectionId )
		{
			$this->Name = $sectionId;
		}
		
		//////////////////////////////////////////////////
		//
		// 		On Response - This is where 'Response' is
		//			processed. Here syncronization of
		//			controls should take place from variables
		//			to Response.
		//
		
		function __protected__OnResponse()
		{
			?>
			<!-- 
				It would be very nice, that divs are generated from javascript itself,
				but this is a low priority for now - Imran Salim 
			-->
			<div id="divInstallBar<?php $this->Mangle()?>" class="styleInstallBar">
				<div id="divTitle<?php $this->Mangle()?>" class="styleInstallTitle">Title</div>
				<div id="divMessageFromServer<?php $this->Mangle()?>">
				</div>
				<div id="divMessageFromClient<?php $this->Mangle()?>">
				</div>
				<?php if ( $this->MessageFromClient != '' )
					{
						// Set MessageFromClient's Div's height to 0
					} 
				?>
			</div>
			<!-- ----------------------------------------------
						Remote Scripting 
			------------------------------------------------ -->		
			<?php 
				if ( $this->ServerURL == null || $this->ServerURL == "" )
					print ( "Error : ".$this->FullName()." - Missing ServerURL" );
					
				$ServerURL = $this->ServerURL."?SectionId=".$this->GetSectionId();					
			?>
			
			<!-- MESSAGE RECEIVER FROM CLIENT - This code received message from client -->
			<!-- The code in iframe loads, and resubmits after sleeping for a small time. As soon 
			as the code is loaded, it call backs functions on client side, this causing the effoct
			of server calling function on client. This process continues until end condition is reached.
			-->
			<iframe id="frmInstallStatus_<?php $this->Mangle(); ?>" src="<?php print ($ServerURL) ?>"  scrolling=no frameborder=no height=0 width=0>
				<!-- To see the code that is placed in this frame, please look at Server's php file -->
			</iframe>

			<div id=divDebug<?php $this->Mangle(); ?>>
			</div>

			<script language="javascript">

				//
				// Only occurs on load
				//
				divTitle<?php $this->Mangle()?>.innerText = "<?php print( $this->Title ); ?>";
				divMessageFromClient<?php $this->Mangle()?>.innerText = "<?php print( $this->MessageFromClient ); ?>";
				
			</script>
			
			<?php
		}
	}
?>

<style type="text/css">

	.styleInstallBar 
	{
		border:solid 1 silver;
		text-align:left;
		width:350px;
		height:50px;
		background:white;
		text-align:center;
	}

	.styleInstallTitle 
	{ 
		text-align:center;
		font-weight:bold 
	}

</style>

<!-- --------------------------------------------------------------------
--------------------------------------------------------------------- -->
<?php
	// X $installClient = new InstallClient( "BACKUPAPPLICATION_LOCAL_REQUEST", null, "/dataprotection/server/InstallServer.php");
	// X $installClient->Title = "Install Control";
	// X $installClient->MessageFromClient = "Message from client";
	// X $installClient->Display();
?>