<?php // Global Front End Functions
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

class client_info
{
	var $platform;
	var $browser;

	function client_info()
	{
    // Get OS
    if (strstr(PHP_OS, "Linux"))
      $this->platform = "Linux";
    else
      $this->platform = "Windows";
   		
		// Next, determine the browser they are using		
		if ( preg_match("/Opera ([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found) &&
			   strstr($this->get_user_agent(), "MSIE") )
		{
			// This will identify the Opera browser even when it tries to ID itself
			// as MSIE 5.0			
		 	$this->browser = "Opera " . $found[1];
		}
		else if ( preg_match("/Opera ([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found) &&
				 strstr($this->get_user_agent(), "Mozilla") )
		{
		  	// Finds Opera if ID's itself as Mozilla based browser
		 	$this->browser = "Opera " . $found[1];
		}
		else if ( preg_match("/Opera\/([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found) )
		{
		  // Finds Opera when ID'ing itself as Opera
		  $this->browser = "Opera " . $found[1];
		}
    else if ( preg_match("/Netscape[0-9]\/([0-9]{1,2}\.[0-9]{1,2})/i", $this->get_user_agent(), $found) )
    {
		 	// For Netscape 6.x
    	$this->browser = "Netscape " . $found[1];
    }
		else if ( preg_match("/Mozilla\/([0-9]{1}\.[0-9]{1,2}) \[en\]/i", $this->get_user_agent(),$found) )
    {
		  // For Netscape 4.x
    	$this->browser = "Netscape " . $found[1];
    }		
    else if ( preg_match("/MSIE ([0-9]{1,2})/i", $this->get_user_agent(), $found) )
    {
			// For MSIE
    	$this->browser = $found[0];
    }    
		else
		  $this->browser = $this->get_user_agent();
	}
  
	// Return the platform detected
  function get_client_platform()
  {
  	return ($this->platform);
  }
  
  // Return the browser that we detected
  function get_client_browser()
	{
  	return ($this->browser);
  }
  
  // Return the user agent string
  function get_user_agent()
  {
  	return $_SERVER['HTTP_USER_AGENT'];
  }
  
}

/*************************************************
* This function validates diagconfig.xml.  You   *
* can pass it just a path to validate if the path*
* exists or you can pass it a path and a         *
* attribute to validate.                         *
*************************************************/
function checkDiagConfig($tag, $att="", $val="")
{
  $dom = LoadXmlDocument($_SESSION["diagsDirectory"]."diagconfig.xml");
  $diagConfig = xpath_new_context($dom->document_element());
  $obj = xpath_eval($diagConfig, $tag);
  if (count($obj->nodeset)) // did it find the tag?
  {
    if ($att == "") // if no atribute validation
      return true;
    else // validate attributes
    {
      $attribute = $obj->nodeset[0]->get_attribute($att);
      if ($attribute == $val) // does the attribute found equal the attribute to validate
        return true;
      else
        return false;
    }
  }
  else
    return false;
}

function IsFactory()
{
  return checkDiagConfig("/factory");
}

function IsPhoenix()
{
  return (getenv("PHOENIX") != NULL);
}

function IsDiagsCD()
{
  return ( getenv("HPDIAGS_CD") != NULL );
}

function IsOnline()
{
  return ( !IsPhoenix() && !IsDiagsCD());
}

function IsDiagnosable()
{
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = @xpath_new_context($idXml->document_element());
  $devices = @xpath_eval($idXpath, "/diagOutput/category/device[@diagnosable='1']");
  if (count($devices->nodeset))
    return 1;
  else
    return 0;
}


/********************************************
* This function will return a two character *
* formated language string retrieved from   *
* the browser                               *
********************************************/
function GetLanguage()
{
  $result = "en"; // default to English

  if (IsPhoenix() || IsDiagsCD())
  {
    $phoenixLanguageString = @file_get_contents("/root/compaq/language.txt");
    // we are only interested in the 1st three charcters
    if (strlen($phoenixLanguageString) > 3)
      $phoenixLanguageString = substr($phoenixLanguageString, 0, 3);
    switch ($phoenixLanguageString)
    {
      case "ENG": $result = "en"; break;
      case "FRE": $result = "fr"; break;
      case "ITA": $result = "it"; break;
      case "GER": $result = "de"; break;
      case "SPA": $result = "es"; break;
      case "JPN": $result = "ja"; break;
      default: $result = "en";
    }
  }

  else
  {
    $result = $_SERVER["HTTP_ACCEPT_LANGUAGE"];
    // we are only interested in the 1st two charcters
    if (strlen($result) > 2)
      $result = substr($result, 0, 2);
    else if (strlen($result) < 2)
      $result = "en"; // English is the default, in case there is not a 2-character code
  }

  // if it's not one of our supported languages, set it to English
  if ($result != "en" &&
      $result != "fr" &&
      $result != "it" &&
      $result != "de" &&
      $result != "es" &&
      $result != "ja")
    $result = "en";

  return $result;
}


/********************************************
* This function will  load an XML file into *
* a DomDocument without the localization    *
* character set problems we have observed   *
* when we try to use domxml_open_file       *
********************************************/
function LoadXmlDocument($filename)
{
  $fileContents = @file_get_contents($filename);
  $result = @new DomDocument($fileContents);
  return $result;
}


/********************************************
* This function builds a multi-deminsional  *
* array that contains the translations. The *
* first element of the array contains the   *
* English string and the second contains    *
* translated string.  It will load up the   *
* proper sdl.xx.xml translation file.  xx   *
* is the argument passed in - $slang        *
* Arg1: the language to translate into		*
********************************************/
function loadTransArray($slang)
{
  $translationArray = array();

  $sdlFile = $_SESSION["diagsDirectory"]. "sdl.".$slang.".xml";
  $commonFile = $_SESSION["diagsDirectory"]. "common.".$slang.".xml";

  // if language is English, we will load the English phrases
  // from the Spanish XML file, since we don't have an English-only XML file
  if ($slang == "en")
  {
    $sdlFile = $_SESSION["diagsDirectory"]. "sdl.es.xml";
    $commonFile = $_SESSION["diagsDirectory"]. "common.es.xml";
  }
 
  $real_pathnames[0] = realpath($sdlFile);
  $real_pathnames[1] = realpath($commonFile);

  foreach ($real_pathnames as $real_path)
  {
    if ($xmldoc = LoadXmlDocument($real_path)) // open correct sdl.xx.xml for translations
    {	// now populate the transArray with translations...
      $transXpath = xpath_new_context($xmldoc->document_element());
      $strings = xpath_eval($transXpath, "/string");
      $num_strings = count($strings->nodeset);
      for($i=0; $i < $num_strings; $i++)
      {
        $string = $strings->nodeset[$i];
        $id = $string->get_attribute("id");
        $keyXpath = xpath_new_context($string);
        $keys = xpath_eval($keyXpath, "/key");
        $num_keys = count($keys->nodeset);
        if ($num_keys)
        {  // better get here or the sdl.xx.xml file is missing a english key
          $key = $keys->nodeset[0];
          $englishKey = $key->get_content();
          // if the language is English, then the English phrase is all we need
          if ($slang == "en")
          {
            $translationArray[$id] = $englishKey;
          }
          else
          {
            $valueXpath = xpath_new_context($string);
            $values = xpath_eval($valueXpath, "/value");
            $num_values = count($values->nodeset);
            if ($num_values)
            { // hopefully gets here also.  this is the translated string
              $value = $values->nodeset[0];
              $transValue = $value->get_content();
              $translationArray[$id] = $transValue;
            }
            else
            {
              $translationArray[$id] = $englishKey;
            }
          }
        }
      }
    }
  }


  $_SESSION["transArray"] = $translationArray;
  return 1;  
}

/*******************************************
* This function will print the nice pretty *
* buttons that you see in the HTML         *
* Arg1: value of the button                *
* Arg2: the onClick event                  *
*******************************************/
function MakeButton($value, $onClick="", $id="")
{
  $buttonString = $buttonString . "<table border=0 cellspacing=0 cellpadding=0 onclick=\"" . $onClick . "\"><tr>";
  $buttonString = $buttonString . "  <td class=\"button_top_left\"></td>";
  $buttonString = $buttonString . "  <td class=\"button_top\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_top_right\"></td>";
  $buttonString = $buttonString . "  </tr>  <tr>";
  $buttonString = $buttonString . "    <td class=\"button_left\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_middle\"><a href=# class=\"button\" id=\"". $id . "\">"  . $value . "</a></td>";
  $buttonString = $buttonString . "    <td class=\"button_right\"></td>";
  $buttonString = $buttonString . "  </tr><tr>";
  $buttonString = $buttonString . "    <td class=\"button_bottom_left\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_bottom\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_bottom_right\"></td>";
  $buttonString = $buttonString . "  </tr></table>";
  
  return $buttonString;  
}


/*******************************************
* This function gets the browsers language *
* setting and then loads up the proper     *
* translated strings into a mulit-dimen    *
* array with the English string being the  *
* first element
*******************************************/
function TR($translateMe)
{
  $result = $translateMe; // default to english string passed in
  if (isset($_SESSION["transArray"][$translateMe]))
  {
    $result = $_SESSION["transArray"][$translateMe];
  }
  return $result;
}


function SurveyOnly()
{
  $dom = LoadXmlDocument($_SESSION["diagsDirectory"]."diagconfig.xml");
  $diagConfig = xpath_new_context($dom->document_element());
  $mode = xpath_eval($diagConfig, "/mode");
  if (count($mode->nodeset))
  {
    $surveyOnly = $mode->nodeset[0]->get_attribute("surveyOnly");    
    if ($surveyOnly == "1")
    {
      $envior = $mode->nodeset[0]->get_attribute("envior");
      if ($envior == "online" && IsOnline())
        return true;
      else if ($envior == "smartstart" && IsPhoenix())
        return true;
      else
        return false;  
    }
    else
     return false;
  }
  else
    return false;
}

// Parses a string that was from the crontab into an array
function ParseCronField($field, $minVal, $maxVal)
{
  $result = FALSE;

  if (!($minVal < $maxVal))
    return $result;

  // fill the array to FALSE
  $result = array_fill($minVal, $maxVal+1, FALSE);

  // first we'll get all the ranges (delimited by commas)
  $tokens = split("[, \t]", $field);
  if ($tokens) foreach($tokens as $rangeToken)
  {    // see if there's a '/<number>' specified with this range (meaning to skip by that number)
    $skipBy = 1;
    $slashpos = strrpos($rangeToken, '/');
    if ($slashpos)
    {
      $skipByStr = substr($rangeToken, $slashpos + 1);
      if (is_numeric($skipByStr))
        $skipBy = max(1, intval($skipByStr));
      $rangeToken = substr($rangeToken, 0, $slashpos);
    }

    $rangeFirst = 0;
    $rangeSecond = 0;

    // an asterisk('*') always means minVal - maxVal
    if ($rangeToken == "*")
    {
      $rangeFirst = $minVal;
      $rangeSecond = $maxVal;
    }
    // otherwise range token should begin with digit
    else if (is_numeric($rangeToken[0]))
    {
      $dashpos = strpos($rangeToken, '-');
      if ($dashpos)
      {
        $rangeFirst = intval(substr($rangeToken, 0, $dashpos));
        $rangeSecond = intval(substr($rangeToken, $dashpos + 1));
      }
      else
      {
        $rangeFirst = intval($rangeToken);
        $rangeSecond = $rangeFirst;
      }
    }

    // loop from $rangeFirst through $rangeSecond
    for ($i = $rangeFirst; $i <= $rangeSecond; $i += $skipBy)
    {
      if ($i >= $minVal && $i <= $maxVal)
        $result[$i] = TRUE;;
    }
  }

  return $result;
}
/********************************************************
* This function will replace a string (ToReplaceText))  *
* that resides inside another string (rStr) with a new  *
* string (ReplaceText) and return the modified string   *
********************************************************/
function ReplaceString($rStr,$ToReplaceText,$ReplaceText) 
{
	$rTempStr=explode($ToReplaceText,$rStr);
	$rStr=implode($ReplaceText,$rTempStr);
	return $rStr;
}

// remove string from a string
function StripString($rStr,$StripText) 
{
	$rTempStr=explode($StripText,$rStr);
	$rStr=implode("",$rTempStr);
	return $rStr;
}

function outputTableContent(&$oss, $obj, $depth, &$bgcolor)
{  
   //$catCaption = $obj->get_attribute("caption");
   //$oss = $oss . sprintf("%s", $catCaption);
  $caption = $obj->get_attribute("caption");
  $value = $obj->get_attribute("value");
  $description = $obj->get_attribute("description");
  $testOnly = $obj->get_attribute("testOnly");
  $techDetail = $obj->get_attribute("techDetail");
  $hexData = $obj->get_attribute("hexData");
  $tdClass = "";
  $colspan = 1;
  $fontColor = "";
  
  if ($testOnly == "1" || ($_SESSION["surveyLevel"] == "Summary" && ($techDetail == "1" || $hexData == "1")))
    return;   //Do not print out - do nada - skip the entire process

  if ($depth == 0) // if heading
  {
    if ($caption == "")
      $caption = TR("MSG_UNDEFINED");
    $bgcolor = "#968f89";
    $tdClass = "subhead";
    $colspan = 2;
    $fontColor = "white";
  }
  else if ($depth == 1) // if sub heading
  {
    if ($caption == "")
      $caption = TR("MSG_UNDEFINED");
    if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
      $bgcolor = "#eeeeee";
    else
      $bgcolor =  "#ffffff";
    $fontColor = "black";
    $tdClass = "subhead";
  }
  else
  {
    if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
      $bgcolor = "#eeeeee";
    else
      $bgcolor =  "#ffffff";
    $fontColor = "black";
    $tdClass = "normal";
    $colspan = 1;
  }

  // no matter what else, if it's hex data set it as follows:
  if ($obj->get_attribute("hexData") == "1")
  {
    $tdClass = "hexdata";    
    $colspan = 2;
  }

  $compareResult = $obj->get_attribute("compareResult");
  if ($compareResult != "" && $compareResult != "nestedChanges")
  {
    $fontColor = "#ff3333";
  }

  $oss = $oss . sprintf("  <tr>\n");
  $oss = $oss . sprintf("<td bgcolor='%s' class='%s' colspan=%d", $bgcolor, $tdClass, $colspan);
  $oss = $oss . sprintf("><font color='%s'>\n", $fontColor);

  for ($i = 0; $i < $depth; $i++)
  {
    $oss = $oss . sprintf("&nbsp;&nbsp;&nbsp; ");
  }

  $oss = $oss . sprintf("%s", $caption);

  if ($colspan == 2)
  {
    //
    // Lets add the description as long as it has not been
    // updated once before
    //
    if ($value != "" || $description != "")
    {                                    
      if (!@strstr($caption, $description))
      {
        $oss = $oss . sprintf(" - ");
      }
      else
      {
        $oss = $oss . sprintf(" &nbsp; ");
      }
    }
  }
  else
  {
    $oss = $oss . sprintf(" </font></td><td bgcolor='%s'><font color='%s'> ", $bgcolor, $fontColor);
  }

  if ($value != "")
  {
    if ($value[0] == ' ')
    {
      $value = substr($value, 1);
      $value = "&nbsp; " . $value;
    }

    $oss = $oss . $value;
  }
  else if ($description != "")
  {
    if ($description[0] == ' ')
    {
      $description = substr($description, 1);
      $description = "&nbsp; " . $description;
    }

    //
    // Lets add the description as long as it has not been
    // updated once before
    //
    if (!strstr($caption, $description))
    {
      $oss = $oss . $description;
    }
  }
  else
  {
    $oss = $oss . "&nbsp; ";
  }

  $oss = $oss . " </font></td></tr>\n";
  

  // Iterate through nested objects and call this function recursively.
  $nestedObjects = $obj->child_nodes();
  foreach ($nestedObjects as $nestedObj)
  {
    $tagname = $nestedObj->tagname;
    if ($tagname == "device" || $tagname == "structure" || $tagname == "property")
    {
      $depth++;
      outputTableContent(&$oss, $nestedObj, $depth, $bgcolor);
      $depth--;
    }
  }
}

function outputCompareContent(&$oss, $Lobj, $Robj, $depth, &$bgcolor, $changesOnly)
{  
   //$catCaption = $obj->get_attribute("caption");
   //$oss = $oss . sprintf("%s", $catCaption);

  $caption = $Lobj->get_attribute("caption");
  $value = $Lobj->get_attribute("value");
  $description = $Lobj->get_attribute("description");
  $testOnly = $Lobj->get_attribute("testOnly");
  $techDetail = $Lobj->get_attribute("techDetail");
  $hexData = $Lobj->get_attribute("hexData");
  $tdClass = "";
  $colspan = 1;
  $fontColor = "";
  $compareResult = $Robj->get_attribute("compareResult");
  
  if ($changesOnly == "on" && $compareResult == "")
  {
    //do nothing - do not display it.
  }
  else
  {
    if ($testOnly == "1" || ($_SESSION["surveyLevel"] == "Summary" && ($techDetail == "1" || $hexData == "1")))
      return;   //Do not print out - do nada - skip the entire process

    if ($depth == 0) // if heading
    {
      if ($Lcaption == "")
        $Lcaption = TR("MSG_UNDEFINED");
      $bgcolor = "#968f89";
      $tdClass = "subhead";
      $colspan = 2;
      $fontColor = "white";
    }
    else if ($depth == 1) // if sub heading
    {
      if ($Lcaption == "")
        $Lcaption = TR("MSG_UNDEFINED");
      if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
        $bgcolor = "#eeeeee";
      else
        $bgcolor =  "#ffffff";
      $fontColor = "black";
      $tdClass = "subhead";
    }
    else
    {
      if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
        $bgcolor = "#eeeeee";
      else
        $bgcolor =  "#ffffff";
      $fontColor = "black";
      $tdClass = "normal";
      $colspan = 1;
    }

    // no matter what else, if it's hex data set it as follows:
    if ($Lobj->get_attribute("hexData") == "1")
    {
      $tdClass = "hexdata";    
      $colspan = 2;
    }


    $compareResult = $Robj->get_attribute("compareResult");
    if ($compareResult != "" && $compareResult != "nestedChanges")
    {
      $fontColor = "#ff3333";
    }

    $oss = $oss . sprintf("  <tr bgcolor='%s'>\n", $bgcolor);
    $oss = $oss . sprintf("<td width=25%% class='%s' colspan=%d><font color='%s'>\n", $tdClass, $colspan, $fontColor);

    if ($compareResult != "" && $compareResult != "nestedChanges")
      $oss = $oss . sprintf("<img src='change.jpg'>");

    for ($i = 0; $i < $depth; $i++)
    {
      $oss = $oss . sprintf("&nbsp;&nbsp;&nbsp; ");
    }

    $oss = $oss . sprintf("%s", $caption);

    if ($colspan == 2)
    {
      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if ($value != "" || $description != "")
      {                                    
        if (!@strstr($caption, $description))
        {
          $oss = $oss . sprintf(" - ");
        }
        else
        {
          $oss = $oss . sprintf(" &nbsp; ");
        }
      }
    }
    else
    {
      $oss = $oss . sprintf(" </font></td><td width=25%%><font color='%s'> ", $fontColor);
    }

    if ($value != "")
    {
      if ($value[0] == ' ')
      {
        $value = substr($value, 1);
        $value = "&nbsp; " . $value;
      }

      $oss = $oss . $value;
    }
    else if ($description != "")
    {
      if ($description[0] == ' ')
      {
        $description = substr($description, 1);
        $description = "&nbsp; " . $description;
      }

      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if (!strstr($caption, $description))
      {
        $oss = $oss . $description;
      }
    }
    else
    {
      $oss = $oss . "&nbsp; ";
    }

    $oss = $oss . " </font></td>\n";
  
  ////// RIGHT OBJECT  
    $caption = $Robj->get_attribute("caption");
    $value = $Robj->get_attribute("value");
    $description = $Robj->get_attribute("description");
    $testOnly = $Robj->get_attribute("testOnly");
    $techDetail = $Robj->get_attribute("techDetail");
    $hexData = $Robj->get_attribute("hexData");
  
    $oss = $oss . sprintf("<td width=25%% class='%s' colspan=%d", $tdClass, $colspan);
    $oss = $oss . sprintf("><font color='%s'>\n", $fontColor);

    for ($i = $headingDepth; $i < $depth; $i++)
    {
      $oss = $oss . sprintf("&nbsp;&nbsp;&nbsp; ");
    }

    $oss = $oss . sprintf("%s", $caption);

    if ($colspan == 2)
    {
      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if ($value != "" || $description != "")
      {                                    
        if (!@strstr($caption, $description))
        {
          $oss = $oss . sprintf(" - ");
        }
        else
        {
          $oss = $oss . sprintf(" &nbsp; ");
        }
      }
    }
    else
    {
      $oss = $oss . sprintf(" </font></td><td width=25%%><font color='%s'> ", $fontColor);
    }

    if ($value != "")
    {
      if ($value[0] == ' ')
      {
        $value = substr($value, 1);
        $value = "&nbsp; " . $value;
      }

      $oss = $oss . $value;
    }
    else if ($description != "")
    {
      if ($description[0] == ' ')
      {
        $description = substr($description, 1);
        $description = "&nbsp; " . $description;
      }

      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if (!strstr($caption, $description))
      {
        $oss = $oss . $description;
      }
    }
    else
    {
      $oss = $oss . "&nbsp; ";
    }

    $oss = $oss . " </font></td></tr>\n";

  }

  // Iterate through nested objects and call this function recursively.
  
  
  $LobjChildren = $Lobj->child_nodes(); // we have to use child nodes for the count or we see weird results on some os'
  $LobjXpath = @xpath_new_context($Lobj);
  $LnestedObjects = @xpath_eval($LobjXpath, "/*");
  
  $RobjXpath = @xpath_new_context($Robj);
  $RnestedObjects = @xpath_eval($RobjXpath, "/*");

  for ($i=0; $i < count($LobjChildren); $i++)
  {
    $LnestedObj = $LnestedObjects->nodeset[$i];
    $RnestedObj = $RnestedObjects->nodeset[$i];
    $tagname = $LnestedObj->tagname;
    if ($tagname == "device" || $tagname == "structure" || $tagname == "property")
    {
      $depth++;
      outputCompareContent(&$oss, $LnestedObj, $RnestedObj, $depth, $bgcolor,$changesOnly);
      $depth--;
    }
  }
}

function getDiagVersion()
{
  system($_SESSION["diagsDirectory"] ."hpdiags -diagversion 1>".$_SESSION["diagsDirectory"]."diagversion.txt");
  
  $ver = @file_get_contents($_SESSION["diagsDirectory"]."diagversion.txt");
  
  return substr($ver,13,6);
}

function IMLSupported()
{
  $inlString;
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = xpath_new_context($idXml->document_element());
  $imlLog = @xpath_eval($idXpath, "/diagOutput/category[@name='miscellaneous']/structure[@name='imlLog']");
  if (count($imlLog->nodeset))
    $imlString = $imlLog->nodeset[0]->get_attribute("caption");
  if ($imlString == "" || strstr($imlString, "Not available"))
    return false;
  else
    return true;
}

function getDirectoryContents($path)
{
  if ($handle = @opendir($path))
  {
    $i=0;
    while (false !== ($file = @readdir($handle)))
    {
      if ($file != "." && $file != "..")
      {
        $contents[$i]=$file;
        $i++;
      }
    }
    closedir($handle);    
  }
  
  return $contents;
}

function IsUnitedLinux()
{
  if (file_exists("/etc/UnitedLinux-release"))
    return true;
  else
    return false;
}

function IsSLES9()
{
  if ($fh = @fopen("/etc/SuSE-release", "r"))
  {
    $buff = fgets($fh, 128);
    if (strstr($buff, "9"))
      return true;
    else
      return false;
  }
  else
    return false;
}

function getPathToFloppy()
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
  {
    if (IsUnitedLinux() || IsSLES9())
      return "/media/floppy/";
    else
      return "/mnt/floppy/";
  }
  else
    return "a:\\";
}
 
function SL()
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
    return "/";
  else
    return "\\";
}

function getIdResult()
{
  $idXml = new DomDocument($_SESSION["idResult"]);
  return xpath_new_context($idXml->document_element());
  return @xpath_eval($idXpath, "/diagOutput");    
}

function getBuildVersion()
{
  $idXpath = getIdResult();
  $diagOutput = @xpath_eval($idXpath, "/diagOutput");
  if (count($diagOutput->nodeset))
    return $diagOutput->nodeset[0]->get_attribute("buildVersion");
  else
    return;
}

function getBuildDate()
{
  $idXpath = getIdResult();
  $diagOutput = @xpath_eval($idXpath, "/diagOutput");
  if (count($diagOutput->nodeset))
    return $diagOutput->nodeset[0]->get_attribute("buildDate");
  else
    return;
}

function getComputerName()
{
  $idXpath = getIdResult();
  $hostNameObj = @xpath_eval($idXpath, "/diagOutput/category[@name='miscellaneous']/structure[@name='systemSummary']/property[@name='hostName']");
  if (count($hostNameObj->nodeset))
    return $hostNameObj->nodeset[0]->get_attribute("value");
  else
    return;
}

function getSystemSerialNumber()
{
  $idXpath = getIdResult();              
  $serialNumberObj = @xpath_eval($idXpath, "/diagOutput/category[@name='assetControl']/structure[@name='productIdentification']/property[@name='serialNumber']");
  if (count($serialNumberObj->nodeset))
    return $serialNumberObj->nodeset[0]->get_attribute("value");
  else
    return;
}


/**************************************
* Checks to see if $device is mounted *
* ex. IsMounted("floppy")             *
**************************************/
function IsMounted($device)
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  
  if ($os == "Windows")
    return true;

  if (IsSLES9())
  { // We have to do this on SLES9 b/c when you mount a device that does not exist - it does not return an error
    $systemCallError = "";
    $returnString = "";
    if ($device == "floppy")
      $device = getPathToFloppy();
    $systemCallString = sprintf("<systemCall>ls -l %s</systemCall>", $device);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
    if (strstr($returnString, "No medium"))
      return false;
    else
      return true;
  }
  else
  {
    $handle = @fopen("/proc/mounts", "r");
    if ($handle)
    {
      while (!feof($handle))
      {
        $buffer = fgets($handle,4096);
      
        if (strstr($buffer,$device))
          return true;
      }
      fclose($handle);
    }
  }
  
  return false;
}

function SaveFile($filename, $location, $oss)
{
  if ($filename != "" && !strstr($filename, "..") && !strstr($filename, "/") && !strstr($filename, "\\"))
  {
    $length = strlen($oss);      
   
    $ci = new client_info();
    $os = $ci->get_client_platform();
    if ($location == "floppy")
    {    
      if ($os == "Linux" || $os == "Unix")
      {
        $systemCallError = "";
        $returnString = "";
        $systemCallString = sprintf("<systemCall>mount %s</systemCall>", getPathToFloppy());
        ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
        $file = session_save_path() . "tmp.html";  // for some reason we have to first save to a tmp file in Linux - maybe time issue
      }
      else
      {
        if (disk_free_space("a:\\") < $length)
          return 2; // disk to small
        $file = "a:\\" . $filename;
      }
    }
    else if ($location == "diskonkey")
    {
      if (!mountUSB("Transparent SCSI"))
        return 1;

      $systemCallError = "";
      $returnString = "";
      $systemCallString = sprintf("<systemCall>mount /mnt/diskonkey</systemCall>");
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
      $file = session_save_path() . "tmp.html";
    }
    else if ($location == "usb")
    {
      if (!mountUSB("Floppy"))
        return 1;
      
      $file = session_save_path() . "tmp.html";
    }
    else
      $file = $_SESSION["diagsDirectory"] . $filename;
 
    $ci = new client_info();
    $os = $ci->get_client_platform();
	  	     
    // check to see if there is a floppy drive
    if ($location == "floppy" && (!IsMounted("floppy")) && ($os == "Linux" || $os == "Unix"))
    {
      return 1; // no floppy in drive
    }
    else if($fh = @fopen($file, "w"))
    {
      $res = fwrite($fh, $oss);
      fclose($fh);
      
      if ($os == "Linux" || $os == "Unix") 
      {         
        if ($location == "floppy")
        {
          if (disk_free_space(getPathToFloppy()) < $length)
            return 2; // disk to small
          
          $systemCallString = sprintf("<systemCall>cp %s %s%s</systemCall>", $file,getPathToFloppy(), $filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          $result = true;
          if (strstr($returnString, "No") || strstr($returnString, "Read-only")) // diskette full
          {
            $result = false;
          }

          $systemCallString = sprintf("<systemCall>umount %s</systemCall>", getPathToFloppy());
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);

          if (!$result)
            return 2; // diskette full
        }
        else if ($location == "diskonkey")
        {
          if (disk_free_space("/mnt/diskonkey/") < $length)
            return 2; // disk to small

          $systemCallString = sprintf("<systemCall>cp %s /mnt/diskonkey/%s</systemCall>", $file, $filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);        

          $systemCallString = sprintf("<systemCall>umount /mnt/diskonkey</systemCall>");
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
        }
        else if ($location == "usb")
        {
          if (disk_free_space("/mnt/usb/") < $length)
            return 2; // disk to small

          $systemCallString = sprintf("<systemCall>cp %s /mnt/usb/%s</systemCall>", $file, $filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          
          $result = true;
          if (strstr($returnString, "No") || strstr($returnString, "Read-only")) // full or wp
          {
            $result = false;
          }
          
          $systemCallString = sprintf("<systemCall>umount /mnt/usb</systemCall>");
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          
          if (!$result)
            return 2; // diskette full

        }  
        else // must be hard drive
        {
          $systemCallString = sprintf("<systemCall>cp %s %s%s</systemCall>", $file,$_SESSION["diagsDirectory"],$filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);        
        }
      }
      else if ($length != $res)
      {
        return 2; // disk full - Windows
      }
      
      return 0;  //passed - whew!
    }
    else
    {  // Error Opening File
      return 3;
    }
  }
  else
  {
    return 4;
  }
}

function mountUSB($device)
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
  {
    $scsiHost = "";
    $devsg = "";
    $devsd = "";
    $foundIt = false;

    for ($i=0; $i < 10; $i++)
    {
      for ($j=0; $j < 7; $j++)
      {
        if ((IsSLES9() || IsPhoenix()) && (!IsDiagsCD()))
        {
          $usbProcPath = "/proc/scsi/usb-storage/" . $i;
        }
        else
          $usbProcPath = "/proc/scsi/usb-storage-" . $i ."/" . $j;
        $handle = @fopen($usbProcPath, "r");
        if ($handle)
        {
          while (!feof($handle)) 
          {
            $buffer = fgets($handle, 4096);
            if (strstr($buffer, "Host"))
            {
              $scsiHost = substr($buffer,8,5);
            }
            if (strstr($buffer,$device))
            {
              $foundIt = true;
              $j = 8;
              $i = 11;
              break; // we found the USB device
            }
          }
          if ($foundIt)
            break;
        }
        if ($foundIt)
         break;
      }
      @fclose($handle);
    }

    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>/opt/hp/hpdiags/sg_scan</systemCall>", $resultString, $compareError);

    if ($resultString && $foundIt)
    {
      if (@strstr($resultString, $scsiHost))
      {      
        $pieces = explode("&#10;", $resultString);
        $size = count($pieces);

        for ($i=0; $i < $size; $i++)
        {
          if (strstr($pieces[$i], $scsiHost))
          {
            $piece = strstr($pieces[$i], "/dev"); // make sure that we have the /dev/XXX
            $devsg = substr($piece, 0, strpos($piece, ":"));
          }
        }
      }
      else
        return false;
    }

    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>/opt/hp/hpdiags/sg_map</systemCall>", $resultString, $compareError);

    if ($resultString)
    {
      if (@strstr($resultString, $devsg))
      {
         $pieces = explode("  ",$resultString);
         $size = count($pieces);

         for ($i=0; $i < $size; $i++)
         {
           if (strstr($pieces[$i],$devsg))
             $devsd = substr($pieces[$i+1], 0, 8); // 8 represents /dev/sxx - tried using strpos but didnt work
         }
      }
      else
        return false;
    }

    if ($devsd == "")
      return false;

    if ($device == "Transparent SCSI") //if it's a usb key we have to have a different moint point
      $mountPoint = "diskonkey";
    else
      $mountPoint = "usb"; // if usb floppy

    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mkdir /mnt/".$mountPoint."</systemCall>", $resultString, $compareError);

    $mountCmd = sprintf("<systemCall>mount %s /mnt/%s</systemCall>", $devsd, $mountPoint);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $mountCmd, $resultString, $compareError);

    if (strstr($resultString, "can't find") || strstr($resultString, "is not a valid") || strstr($resultString, "medium"))
      return false;
    else if (strstr($resultString, "you must specify"))
    {  // sometimes we need to attach a 1 to the end of the device for it to work
      $mountCmd = sprintf("<systemCall>mount %s1 /mnt/%s</systemCall>", $devsd, $mountPoint);
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $mountCmd, $resultString, $compareError);
      if (strstr($resultString, "can't find") || strstr($resultString, "is not a valid"))
        return false;
      else
        return true;
    }
    else
      return true;
  }
}

function checkForUSBDevice($device)
{
  $foundIt = false;
  $foundItAttached = false;
  $attached = false;
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
  {
    $scsiHost = "";
    $devsg = "";
    $devsd = "";

    for ($i=0; $i < 10; $i++)
    {
      for ($j=0; $j < 7; $j++)
      {
        if ((IsSLES9() || IsPhoenix()) && (!IsDiagsCD()))
        {
          $usbProcPath = "/proc/scsi/usb-storage/" . $i;
          $j = 6;
        }
        else
          $usbProcPath = "/proc/scsi/usb-storage-" . $i ."/" . $j;
          
        $handle = @fopen($usbProcPath, "r");
        if ($handle)
        {
          while (!feof($handle)) 
          {
            $buffer = fgets($handle, 4096);

            if (strstr($buffer, "Host"))
            {
              $scsiHost = substr($buffer,8,5);
            }
            
            if (strstr($buffer,$device))
              $foundIt = true;
            
            if ($foundIt && strstr($buffer, "Attached:"))
            {
              $attached = true;
              if (strstr($buffer, "Yes"))
                $foundItAttached = true;                            
            }
          }
          if ($attached)
            break;
        }
        if ($attached)
         break;
      }
      @fclose($handle);
      if ($foundIt)
        break;
    }
  }
  
  //if we found it but it did not have the Attached entry at all
  if ($foundIt && !$attached)
    $foundItAttached = true;
    
  return $foundItAttached;
}

function my_dump_node($node,$encoding)
{
   $domNode = domxml_new_doc("1.0");
   $clonedNode = $node->clone_node(true);
   $domNode->append_child($clonedNode);
   $result = $domNode->dump_mem(true,$encoding);
   $pos = strpos($result,"?>");
   return substr($result,$pos+2);
}

function ConvertAITimeToMinutes($AItime)
{
  $pieces = explode(":",$AItime);
  $hours = $pieces[0];
  $minutes = $pieces[1];
  $seconds = $pieces[2];
  return ($hours * 60) + ($seconds * .01) + $minutes;
}
?>

