%define name vlan
%define version 1.8.0r

Summary: Linux 802.1Q Module
Name: %{name}
Version: %{version}
Release: 14
Vendor: HP
Copyright: GPL
Group: System Environment/Base
Source: vlan-%{version}.tgz
BuildRoot: /var/tmp/%{name}-buildroot

%description
This package contains the Linux Module for 802.1Q VLAN Support and
the vconfig utility to configure VLAN's

%prep
if [ -f /etc/redhat-release ]; then
   if (grep -i "Nahant" /etc/redhat-release >/dev/null) then
      set +x
      # don't install vlan driver on RHEL4 since we support the vlan
      # driver shipped with that distro
      echo -e "\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
      echo -e "\t\tThis vlan package does not need to be built/installed on"
      echo -e "\t\tRed HatEnterprise Linux release 4 (Nahant). The vlan driver"
      echo -e "\t\ton this distribution is supported. A vlan_init package is"
      echo -e "\t\tavailable for Red Hat Enterprise Linux release 4"
      echo -e "\t\tthat automates VLAN creation. The vlan_init package"
      echo -e "\t\tis available from:" 
      echo -e "\t\thttp://h18004.www1.hp.com/support/files/server/us/index.html"
      echo -e "\t\tMore details on how to get the vlan_init package, refer the"
      echo -e "\t\tNote in Operating System section of vlan-<version>.txt file"
      echo -e "\t\tsupplied with this package"
      echo ""
      exit 1
   fi
fi
# remove our buildroot in case it was left by a previous build failure
rm -rf /var/tmp/%{name}-buildroot
%setup -c -b 0

%build
make 


%install
VLAN_KVER=`uname -r | cut -c1-3 | sed 's/2\.[56]/2\.6/'`
if [ "$VLAN_KVER" = "2.6" ]; then
VLAN_DRV=8021q.ko
else
VLAN_DRV=8021q.o
fi

echo "%defattr(-,root,root)" > $RPM_BUILD_DIR/file.list.%{name}
if [ -d /etc ]
then
mkdir -p $RPM_BUILD_ROOT/etc
echo "/etc/vlan.conf" >> $RPM_BUILD_DIR/file.list.%{name}
fi

if [ -d /etc/init.d ]
then
mkdir -p $RPM_BUILD_ROOT/etc/init.d
echo "/etc/init.d/vlan" >> $RPM_BUILD_DIR/file.list.%{name}
fi

if [ -d /lib/modules/`uname -r`/kernel/net/8021q ]
then
mkdir -p $RPM_BUILD_ROOT/lib/modules/`uname -r`/kernel/net/8021q
  echo "/lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}".new" >> $RPM_BUILD_DIR/file.list.%{name}
fi
if [ -d /sbin ]
then
mkdir -p $RPM_BUILD_ROOT/sbin
fi
echo "/sbin/vconfig.new" >> $RPM_BUILD_DIR/file.list.%{name}
if [ -d /usr/share/man/man8 ]
then
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
fi
echo "/usr/share/man/man8/vconfig.8.new.gz" >> $RPM_BUILD_DIR/file.list.%{name}
make install PREFIX=$RPM_BUILD_ROOT
mv -f $RPM_BUILD_ROOT/lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}" \
   $RPM_BUILD_ROOT/lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}".new
mv -f $RPM_BUILD_ROOT/sbin/vconfig $RPM_BUILD_ROOT/sbin/vconfig.new
mv -f $RPM_BUILD_ROOT/usr/share/man/man8/vconfig.8.gz $RPM_BUILD_ROOT/usr/share/man/man8/vconfig.8.new.gz

%preun
VLAN_KVER=`uname -r | cut -c1-3 | sed 's/2\.[56]/2\.6/'`
if [ "$VLAN_KVER" = "2.6" ]; then
VLAN_DRV=8021q.ko
else
VLAN_DRV=8021q.o
fi

/etc/init.d/vlan stop
chkconfig --del vlan > /dev/null 2> /dev/null
if [ -s /etc/rc.config ]; then
    pushd .
    cd /etc/init.d/rc2.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    cd /etc/init.d/rc3.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    cd /etc/init.d/rc4.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    cd /etc/init.d/rc5.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    popd
fi
if [ -f /lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}".new ]; then
      cmp -s /lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}".new \
             /lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}"
   if [ "$?" == 0 ]; then
         # files match
         rm -f /lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}"
   fi
fi

if [ -f /sbin/vconfig.new ]; then
      cmp -s /sbin/vconfig.new /sbin/vconfig
   if [ "$?" == 0 ]; then
         # files match
         rm -f /sbin/vconfig
   fi
fi

if [ -f /usr/share/man/man8/vconfig.8.new.gz ]; then
      cmp -s /usr/share/man/man8/vconfig.8.new.gz /usr/share/man/man8/vconfig.8.gz
   if [ "$?" == 0 ]; then
         # files match
         rm -f /usr/share/man/man8/vconfig.8.gz
   fi
fi
exit 0

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%files -f ../file.list.%{name}
%doc vlan.txt
%doc LICENSE

%post
VLAN_KVER=`uname -r | cut -c1-3 | sed 's/2\.[56]/2\.6/'`
if [ "$VLAN_KVER" = "2.6" ]; then
VLAN_DRV=8021q.ko
else
VLAN_DRV=8021q.o
fi
cp -f /lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}".new \
      /lib/modules/`uname -r`/kernel/net/8021q/"${VLAN_DRV}"
cp -f /sbin/vconfig.new /sbin/vconfig
cp -f /usr/share/man/man8/vconfig.8.new.gz /usr/share/man/man8/vconfig.8.gz

chkconfig --del vlan > /dev/null 2> /dev/null
chkconfig --add vlan > /dev/null 2> /dev/null
if [ -s /etc/rc.config ]; then
    pushd .
    cd /etc/init.d/rc2.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    ln -s ../vlan S11vlan
    ln -s ../vlan K89vlan
    cd /etc/init.d/rc3.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    ln -s ../vlan S11vlan
    ln -s ../vlan K89vlan
    cd /etc/init.d/rc4.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    ln -s ../vlan S11vlan
    ln -s ../vlan K89vlan
    cd /etc/init.d/rc5.d
    rm -f S11vlan >/dev/null 2>/dev/null
    rm -f K89vlan >/dev/null 2>/dev/null
    ln -s ../vlan S11vlan
    ln -s ../vlan K89vlan
    popd
fi
depmod -a > /dev/null 2> /dev/null
exit 0

%postun
# one big if around the preun..... $1 contains number versions after operation
VLAN_KVER=`uname -r | cut -c1-3 | sed 's/2\.[56]/2\.6/'`
if [ "$VLAN_KVER" = "2.6" ]; then
VLAN_DRV=8021q.ko
else
VLAN_DRV=8021q.o
fi
if [ "$1" = 0 ]; then
   rm -f /lib/modules/`uname -r`/kernel/net/"${VLAN_DRV}"
   rm -f /sbin/vconfig
   rm -f /usr/share/man/man8/vconfig.8.gz
fi
depmod -a > /dev/null 2> /dev/null
exit 0

%changelog
